SystemOrganization addCategory: #'Xpf-Multipoint-Core'!

Object subclass: #MultiPointer
	instanceVariableNames: 'pointerID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Core'!

MultiPointer class
	instanceVariableNames: 'eventSemaphore deviceSemaphore'!

MultiPointer class
	instanceVariableNames: 'eventSemaphore deviceSemaphore'!

!MultiPointer class methodsFor: 'instance creation' stamp: 'mig 5/19/2009 10:51'!
allPointers

	^ (0 to: self getPointerCount - 1) collect: [:id | self newForID: id]! !

!MultiPointer class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:53'!
deviceSemaphore

	^ deviceSemaphore ifNil: [self deviceSemaphore: Semaphore new. deviceSemaphore]! !

!MultiPointer class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:07'!
deviceSemaphore: anObject

	deviceSemaphore := anObject.! !

!MultiPointer class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:53'!
eventSemaphore

	^ eventSemaphore ifNil: [self eventSemaphore: Semaphore new. eventSemaphore]! !

!MultiPointer class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:07'!
eventSemaphore: anObject

	eventSemaphore := anObject.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:10'!
getPointerCount

	<primitive: 'primitiveMultiPointerCount' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/19/2009 10:44'!
getPointerCurrentState: aPointerID

	^ MultiPointerState new in: [:state | 
		self pvtGetPointerCurrentState: aPointerID with: state. state]
! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:30'!
getPointerLively: aPointerID

	^ (self pvtGetPointerLively: aPointerID) ~= 0! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 4/22/2009 17:34'!
getPointerName: aPointerID

	| pointerName |
	pointerName := self pvtGetPointerName: aPointerID.
	^ pointerName truncateTo: (pointerName 
			indexOf: (Character value: 0) 
			startingAt: 0 
			ifAbsent: [pointerName size + 1]) - 1! !

!MultiPointer class methodsFor: 'instance creation' stamp: 'mig 5/19/2009 10:51'!
newForID: aPointerID

	^ self new pointerID: aPointerID! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:11'!
pvtGetPointerCurrentState: aPointerID with: aMultiPointerState

	<primitive: 'primitiveMultiPointerCurrentState' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:11'!
pvtGetPointerLively: aPointerID

	<primitive: 'primitiveMultiPointerLively' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:11'!
pvtGetPointerName: aPointerID

	<primitive: 'primitiveMultiPointerName' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'system startup' stamp: 'mig 5/19/2009 12:10'!
registerSemaphores

	self setPointerEventSemaphoreHandle: (Smalltalk registerExternalObject: self eventSemaphore).
	self setPointerDeviceSemaphoreHandle: (Smalltalk registerExternalObject: self deviceSemaphore).! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:11'!
setPointerDeviceSemaphoreHandle: aSemaIndex

	<primitive: 'primitiveMultiPointerDeviceSemaphoreHandle' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:11'!
setPointerEventSemaphoreHandle: aSemaIndex

	<primitive: 'primitiveMultiPointerEventSemaphoreHandle' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'system startup' stamp: 'mig 5/19/2009 12:10'!
unregisterSemaphores

	self setPointerEventSemaphoreHandle: 0.
	self setPointerDeviceSemaphoreHandle: 0.
	
	Smalltalk unregisterExternalObject: self eventSemaphore.
	Smalltalk unregisterExternalObject: self deviceSemaphore.
	
	self eventSemaphore: nil.
	self deviceSemaphore: nil.
! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:12'!
useHardwareMouse

	<primitive: 'primitiveMultiPointerUseHardwareMouse' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:12'!
useSoftwareMouse

	<primitive: 'primitiveMultiPointerUseSoftwareMouse' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer methodsFor: 'comparing' stamp: 'mig 5/19/2009 10:58'!
= aPointer

	^ self pointerID = aPointer pointerID! !

!MultiPointer methodsFor: 'testing' stamp: 'mig 5/19/2009 10:13'!
isLively

	^ self class getPointerLively: self pointerID! !

!MultiPointer methodsFor: 'accessing' stamp: 'mig 5/19/2009 10:12'!
pointerID

	^ pointerID! !

!MultiPointer methodsFor: 'accessing' stamp: 'mig 5/19/2009 10:19'!
pointerID: anInteger

	pointerID := anInteger.! !

!MultiPointer methodsFor: 'accessing' stamp: 'mig 5/19/2009 10:48'!
reset

	self class getPointerCurrentState: self pointerID.! !

!MultiPointer methodsFor: 'accessing' stamp: 'mig 5/19/2009 10:18'!
state

	^ self class getPointerCurrentState: self pointerID! !

Object subclass: #MultiPointerManager
	instanceVariableNames: 'handMorphs deviceUpdateProcess movementProcess keyboardHand multiPointerActive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Core'!

MultiPointerManager class
	instanceVariableNames: 'instance'!

MultiPointerManager class
	instanceVariableNames: 'instance'!

!MultiPointerManager class methodsFor: 'class initialization' stamp: 'mig 5/19/2009 11:44'!
initialize

	super initialize.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
	! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:20'!
instance

	^ instance! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:20'!
instance: anObject

	instance := anObject.! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:37'!
multiPointerActive

	^ self instance notNil and: [self instance multiPointerActive]! !

!MultiPointerManager class methodsFor: 'testing' stamp: 'SR 5/6/2009 10:19'!
pluginAvailable

	^ SmalltalkImage current listBuiltinModules anySatisfy: [:each | each startsWith: 'MultiPointerPlugin']! !

!MultiPointerManager class methodsFor: 'event processing' stamp: 'mig 5/19/2009 11:38'!
processSystemMouseEvent: evtBuf on: aHandMorph
	
	^ self multiPointerActive
		ifFalse: [aHandMorph generateMouseEvent: evtBuf]
		ifTrue: [nil]
! !

!MultiPointerManager class methodsFor: 'system startup' stamp: 'mig 5/19/2009 11:55'!
shutDown: aboutToQuit 

	self instance ifNotNil: [
		self instance shutdown.
		self instance: nil].
	
	super shutDown: aboutToQuit.! !

!MultiPointerManager class methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:57'!
startMoving

	self instance ifNotNil: [ self instance startMoving ]! !

!MultiPointerManager class methodsFor: 'system startup' stamp: 'mig 5/19/2009 11:54'!
startUp: aboutToQuit 

	self pluginAvailable ifTrue: [
		self instance: self new.
		self instance startup].
	
	super startUp: aboutToQuit.! !

!MultiPointerManager class methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:57'!
stopMoving

	self instance ifNotNil: [ self instance stopMoving ]! !

!MultiPointerManager methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:24'!
colorizeHands

	| colorWheel |
	colorWheel := Color wheel: self handMorphs size.
	
	self handMorphs withIndexDo: [:hand :index |
		hand normalCursor: (MultiPointerHandMorph 
			cursorColored: (colorWheel at: index) 
			with: (self keyboardHand = hand ifTrue: [Color black] ifFalse: [Color white]))].! !

!MultiPointerManager methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:48'!
createHandMorphFor: aPointer
	
	^ (self handMorphs anySatisfy: [:each | each pointer = aPointer])
		ifFalse: [ | hand |
			hand := MultiPointerHandMorph new pointer: aPointer.
			self handMorphs add: hand.
			self multiPointerActive ifTrue: [World addHand: hand]].! !

!MultiPointerManager methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:25'!
destroyHandMorphFor: aPointer

	(self handMorphs detect: [:each | each pointer = aPointer] ifNone: [nil])
		ifNotNilDo: [:morph |
			self handMorphs remove: morph.
			World removeHand: morph.
			self keyboardHand = morph ifTrue: [
				self handMorphs
					ifEmpty: [self keyboardHand: World hands first]
					ifNotEmpty: [self keyboardHand: self handMorphs first]]].
! !

!MultiPointerManager methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:23'!
deviceUpdateBlock

	^ [[
			MultiPointer allPointers do: [:pointer |
				pointer isLively
					ifTrue: [ self createHandMorphFor: pointer ]
					ifFalse: [ self destroyHandMorphFor: pointer ]].
			self colorizeHands.
			MultiPointer deviceSemaphore wait.
		] repeat ]! !

!MultiPointerManager methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:23'!
deviceUpdateProcess

	^ deviceUpdateProcess! !

!MultiPointerManager methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:23'!
deviceUpdateProcess: anObject

	deviceUpdateProcess := anObject.! !

!MultiPointerManager methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:21'!
handMorphs

	^ handMorphs! !

!MultiPointerManager methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:21'!
handMorphs: anObject

	handMorphs := anObject.! !

!MultiPointerManager methodsFor: 'initialization' stamp: 'mig 5/19/2009 11:44'!
initialize

	super initialize.
	
	self handMorphs: OrderedCollection new.
	self multiPointerActive: false.
	! !

!MultiPointerManager methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:22'!
keyboardHand

	^ keyboardHand! !

!MultiPointerManager methodsFor: 'accessing' stamp: 'mig 5/19/2009 14:21'!
keyboardHand: anObject

	keyboardHand := anObject.
	self colorizeHands.! !

!MultiPointerManager methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:23'!
movementBlock

	^ [[
			MultiPointer eventSemaphore wait.
			self handMorphs do: [:each | each readEvent]
		] repeat ]! !

!MultiPointerManager methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:23'!
movementProcess

	^ movementProcess! !

!MultiPointerManager methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:23'!
movementProcess: anObject

	movementProcess := anObject.! !

!MultiPointerManager methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:29'!
multiPointerActive

	^ multiPointerActive! !

!MultiPointerManager methodsFor: 'accessing' stamp: 'mig 5/19/2009 11:29'!
multiPointerActive: anObject

	multiPointerActive := anObject.! !

!MultiPointerManager methodsFor: 'system startup' stamp: 'mig 5/19/2009 12:10'!
shutdown

	self stopDeviceDiscovery.
	MultiPointer unregisterSemaphores.! !

!MultiPointerManager methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:27'!
startDeviceDiscovery

	self deviceUpdateProcess ifNotNil: [^self].
	self deviceUpdateProcess: self deviceUpdateBlock fork.
	
	self deviceUpdateProcess name: 'MultiPointer Device Discovery'.! !

!MultiPointerManager methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:39'!
startMoving

	self movementProcess ifNotNil: [^ self].
		
	self handMorphs do: [:hand | 
		hand pointer reset.
		World addHand: hand].

	self keyboardHand: self handMorphs first.

	self multiPointerActive: true.
	MultiPointer useSoftwareMouse.
	
	self movementProcess: self movementBlock fork.
	
	self movementProcess
		name: 'MultiPointer Movement';
		priority: Processor userInterruptPriority.! !

!MultiPointerManager methodsFor: 'system startup' stamp: 'mig 5/19/2009 12:10'!
startup

	MultiPointer registerSemaphores.
	self startDeviceDiscovery.! !

!MultiPointerManager methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:28'!
stopDeviceDiscovery

	self deviceUpdateProcess ifNotNil: [
		self deviceUpdateProcess terminate.
		self deviceUpdateProcess: nil.
		
		MultiPointer allPointers do: [:each |
			self destroyHandMorphFor: each].
		
		self handMorphs: OrderedCollection new].
! !

!MultiPointerManager methodsFor: 'as yet unclassified' stamp: 'mig 5/19/2009 11:41'!
stopMoving

	self movementProcess ifNotNil: [
		self movementProcess terminate.
		self movementProcess: nil].
	
	self handMorphs do: [:each | World removeHand: each].
	MultiPointer useHardwareMouse.

	Sensor eventQueue flush.
	self multiPointerActive: false.
	self keyboardHand: nil.
! !

Object subclass: #MultiPointerState
	instanceVariableNames: 'x y buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Core'!

!MultiPointerState commentStamp: 'mig 5/19/2009 12:04' prior: 0!
MultiPointerState is a wrapper class for the status of a pointer reported by the MultiPointer plugin.
Do not change the instance variable definition because instance variables are set via index by MultiPointerPlugin.!

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
buttons

	^ buttons! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
x

	^ x! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
y

	^ y! !

Object subclass: #MultiPointerWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Core'!

!MultiPointerWidget class methodsFor: 'user interface' stamp: 'SR 5/5/2009 23:18'!
createButton: actionSel label: labelSel
	
	| btn |
	btn := UITheme current
		newLabelIn: World
		label: labelSel. 
	btn 
		vResizing: #spaceFill; 
		hResizing: #spaceFill.
	btn on: #mouseUp send: actionSel to: self.
	^ btn
	! !

!MultiPointerWidget class methodsFor: 'user interface' stamp: 'mig 5/6/2009 22:26'!
grabKeyboardWithEvent: evt from: source

	MultiPointerManager multiPointerActive
		ifTrue: [MultiPointerManager keyboardHand: evt hand].! !

!MultiPointerWidget class methodsFor: 'user interface' stamp: 'mig 5/6/2009 22:25'!
open
	
	(AlignmentMorph newBounds: (50@50 corner: 700@80))
		color: Color yellow;
		addMorph: (self createButton: #grabKeyboardWithEvent:from: label: 'Grab Keyboard');
		openInWorld.! !

!HandMorph methodsFor: '*xpf-multipoint-core-override' stamp: 'mig 5/19/2009 12:20'!
processEvents
	"Process user input events from the local input devices."

	| evt evtBuf type hadAny handleCurrentEvent |
	ActiveEvent ifNotNil: [
		"Meaning that we were invoked from within an event response.
		Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent].
	
	hadAny := false.
	[(evtBuf := Sensor nextEvent) isNil] whileFalse: [
		evt := nil.	"for unknown event types"
		handleCurrentEvent := true.
		type := evtBuf first.
		
		type = EventTypeMouse
			ifTrue: [
				evt := MultiPointerManager processSystemMouseEvent: evtBuf on: self.
				evt ifNil: [handleCurrentEvent := false]].
		type = EventTypeKeyboard 
			ifTrue: [evt := self generateKeyboardEvent: evtBuf].
		type = EventTypeDragDropFiles 
			ifTrue: [evt := self generateDropFilesEvent: evtBuf].
		"All other events are ignored"
		(type ~= EventTypeDragDropFiles and: [evt isNil]) ifTrue: [^self].
		(evt isNil not and: [handleCurrentEvent]) ifTrue: [
			MultiPointerManager multiPointerActive
				ifTrue: [MultiPointerManager instance keyboardHand enqueueEvent: evt]
				ifFalse: [
					"Finally, handle it"
					self handleEvent: evt.
					hadAny := true.

					"For better user feedback, return immediately after a mouse event has been processed."
					(evt isMouse and: [evt isMouseWheel not]) ifTrue: [^self]
				]
		]
	].
	
	"note: if we come here we didn't have any mouse events"
	mouseClickState notNil ifTrue: [
		"No mouse events during this cycle. Make sure click states time out accordingly"
		mouseClickState handleEvent: lastMouseEvent asMouseMove from: self].
	
	hadAny ifFalse: [
		"No pending events. Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent]! !

HandMorph subclass: #MultiPointerHandMorph
	instanceVariableNames: 'queue lastPosition buttons pointer normalCursor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Core'!

!MultiPointerHandMorph class methodsFor: 'misc' stamp: 'mig 5/18/2009 14:51'!
bigCursor

	^ (Cursor extent: 24@26 fromArray: #(
		2r100000000000000000000000
		2r110000000000000000000000
		2r111000000000000000000000
		2r111100000000000000000000
		2r111110000000000000000000
		2r111111000000000000000000
		2r111111100000000000000000
		2r111111110000000000000000
		2r111111111000000000000000
		2r111111111100000000000000
		2r111111111110000000000000
		2r111111111111000000000000
		2r111111111111100000000000
		2r111111111111110000000000
		2r111111111111111000000000
		2r111111111000000000000000
		2r111101111100000000000000
		2r111001111100000000000000
		2r110000111110000000000000
		2r100000111110000000000000
		2r000000011111000000000000
		2r000000011111000000000000
		2r000000001111000000000000
		2r000000000111000000000000
		2r000000000000000000000000
		2r000000000000000000000000
	) offset: 0@0) withMask asCursorForm! !

!MultiPointerHandMorph class methodsFor: 'misc' stamp: 'mig 5/18/2009 14:21'!
cursorColored: aColor with: anotherColor

	^ (self bigCursor)
		replaceColor: Color black withColor: aColor;
		replaceColor: Color white withColor: anotherColor;
		yourself! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/29/2009 17:49'!
buttons

	^ buttons! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:21'!
buttons: newButtons

	buttons := newButtons.! !

!MultiPointerHandMorph methodsFor: 'updating' stamp: 'mig 5/18/2009 14:50'!
changed

	super changed.
	bounds := bounds origin extent: self currentCursor extent.! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/29/2009 17:52'!
createMorphicButtonEvents: aState

	| result |
	result := OrderedCollection new.
	0 to: 2 do: [:each |
		(aState buttons anyMask: (1 bitShift: each*2)) ifTrue: [
			self buttons: (self buttons bitOr: (1 bitShift: (2-each))).
			result add: (MouseButtonEvent new 
				setType: #mouseDown
				position: self lastPosition
				which: (1 bitShift: (2-each))
				buttons: self buttons
				hand: self
				stamp: Time millisecondClockValue)].
		(aState buttons anyMask: (1 bitShift: (each*2)+1)) ifTrue: [
			self buttons: (self buttons bitAnd: ((1 bitShift: (2-each)) bitInvert)).
			result add: (MouseButtonEvent new 
				setType: #mouseUp
				position: self lastPosition
				which: (1 bitShift: (2-each))
				buttons: self buttons
				hand: self
				stamp: Time millisecondClockValue)].
	].
	^ result! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 5/4/2009 10:37'!
createMorphicMoveEvent: aState

	| newPosition evt tempPoint |
	tempPoint := Point x: aState x y: aState y.
	newPosition := self lastPosition + tempPoint.
	
	newPosition = self lastPosition ifTrue: [^ nil].
	
	newPosition := newPosition adhereTo: Display fullBoundingBox.
	evt := MouseMoveEvent new
		setType: #mouseMove
		startPoint: self lastPosition
		endPoint: newPosition
		trail: nil
		buttons: self buttons
		hand: self
		stamp: Time millisecondClockValue.
	self lastPosition: newPosition.
	^ evt! !

!MultiPointerHandMorph methodsFor: 'cursor' stamp: 'mig 5/18/2009 14:18'!
currentCursor

	^ {self temporaryCursor. self normalCursor. NormalCursor} detect: [:cursor| cursor notNil]! !

!MultiPointerHandMorph methodsFor: 'drawing' stamp: 'mig 5/18/2009 14:18'!
drawOn: aCanvas 
	"Draw the hand itself (i.e., the cursor)."

	aCanvas 
		paintImage: self currentCursor
		at: bounds topLeft.! !

!MultiPointerHandMorph methodsFor: 'event handling' stamp: 'SR 5/5/2009 23:03'!
enqueueEvent: aState

	aState isMorphicEvent
		ifTrue: [self queue nextPut: aState]
		ifFalse: [
			self queue nextPut: (self createMorphicMoveEvent: aState).
			aState buttons isZero ifFalse: [
				self queue nextPutAll: (self createMorphicButtonEvents: aState)]].! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/19/2009 10:28'!
handId

	^ self pointer pointerID asString
! !

!MultiPointerHandMorph methodsFor: 'initialization' stamp: 'SR 4/29/2009 17:53'!
initialize

	super initialize.
	self queue: SharedQueue new.
	self lastPosition: 0 asPoint.
	self buttons: 0.
! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
lastPosition

	^ lastPosition! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
lastPosition: anObject

	lastPosition := anObject! !

!MultiPointerHandMorph methodsFor: 'drawing' stamp: 'SR 4/24/2009 13:39'!
needsToBeDrawn

	^ true! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/6/2009 10:41'!
normalCursor

	^ normalCursor! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/18/2009 14:19'!
normalCursor: anObject

	normalCursor := anObject.
	self changed.! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/19/2009 10:22'!
pointer

	^ pointer! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/19/2009 10:22'!
pointer: anObject

	pointer := anObject.! !

!MultiPointerHandMorph methodsFor: 'event handling' stamp: 'mig 5/7/2009 13:54'!
processEvents
	
	ActiveEvent ifNotNil: [
		"Meaning that we were invoked from within an event response. Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent].
	
	self queue isEmpty ifTrue: [
		"No pending events. Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent.
		^ self].

	[self queue isEmpty] whileFalse: [
		self handleEvent: self queue next].! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
queue

	^ queue! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:21'!
queue: anObject

	queue := anObject.! !

!MultiPointerHandMorph methodsFor: 'event handling' stamp: 'mig 5/19/2009 10:27'!
readEvent

	self enqueueEvent: self pointer state.! !

!Cursor class methodsFor: '*xpf-multipoint-core-override' stamp: 'mig 5/18/2009 15:03'!
extent: extentPoint fromArray: anArray offset: offsetPoint 
	"Answer a new instance of me with width and height specified by
	extentPoint, offset by offsetPoint, and bits from anArray.
	The width must be smaller or equal to 32 to fit into an 32-bit bitmap"
	
	(extentPoint x between: 1 and: 32) ifFalse: [
		^ self error: 'cursors must be max. 32 pixels wide'].

	^ super
		extent: extentPoint
		fromArray: (anArray collect: [:bits | bits bitShift: 32 - extentPoint x])
		offset: offsetPoint.
! !

!SharedQueue methodsFor: '*xpf-multipoint-core-override' stamp: 'SR 5/4/2009 10:34'!
nextPut: value 
	"Send value through the receiver. If a Process has been suspended 
	waiting to receive a value through the receiver, allow it to proceed."

	value ifNil: [^ self].
	accessProtect
		critical: [writePosition > contentsArray size
						ifTrue: [self makeRoomAtEnd].
				 contentsArray at: writePosition put: value.
				 writePosition := writePosition + 1].
	readSynch signal.
	^value! !

!SharedQueue methodsFor: '*xpf-multipoint-core' stamp: 'SR 4/29/2009 17:24'!
nextPutAll: aCollection

	aCollection do: [:each | self nextPut: each].! !

!Morph methodsFor: '*xpf-multipoint-core-override' stamp: 'SR 5/6/2009 14:25'!
delete
	"Remove the receiver as a submorph of its owner and make its 
	new owner be nil."

	| aWorld |
	self removeHalo.
	aWorld := self world ifNil: [World].
	"Terminate genie recognition focus"
	"I encountered a case where the hand was nil, so I put in a little 
	protection - raa "
	" This happens when we are in an MVC project and open
	  a morphic window. - BG "
	aWorld ifNotNil: [
		self disableSubmorphFocusForHand: self activeHand.
		self activeHand ifNotNil: [
			self activeHand
				releaseKeyboardFocus: self;
				 releaseMouseFocus: self]].
	owner ifNotNil:[ self privateDelete.
		self player ifNotNilDo: [ :player |
			"Player must be notified"
			player noteDeletionOf: self fromWorld: aWorld]].! !
MultiPointerManager initialize!
